--
-- Map Function Scripts
-- by Blacky_BPG
-- last Changed: 21.03.2014
--
-- ready for use with ExtraFarm Script
--
DigitalAmountMover = {};
local DigitalAmountMover_mt = Class(DigitalAmountMover);
function DigitalAmountMover.onCreate(id)
	g_currentMission:addNonUpdateable(DigitalAmountMover:new(id));
end;
function DigitalAmountMover:new(id, customMt)
	local self = {};
	setmetatable(self, DigitalAmountMover_mt);

	self.id = id;
	self.nodeId = id;
	local fillType = getUserAttribute(id, "fillType");
	if fillType ~= nil then
		self.fillType = Fillable.fillTypeNameToInt[fillType];
	end;
	if self.fillType == nil then
		self.fillType = Fillable.FILLTYPE_LIQUIDMANURE;
	end;

	self.digitPosition = {};
	self.digitPosition["0"] = -1.000;
	self.digitPosition["1"] = -0.106;
	self.digitPosition["2"] = -0.212;
	self.digitPosition["3"] = -0.309;
	self.digitPosition["4"] = -0.414;
	self.digitPosition["5"] = -0.520;
	self.digitPosition["6"] = -0.617;
	self.digitPosition["7"] = -0.722;
	self.digitPosition["8"] = -0.820;
	self.digitPosition["9"] = -0.925;

	local tmp = getUserAttribute(self.id, "digit1");
	if tmp ~= nil then
		self.digits = {};
		self.digits[1] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit1"));
		self.digits[2] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit2"));
		self.digits[3] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit3"));
		self.digits[4] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit4"));
		self.digits[5] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit5"));
		self.digits[6] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit6"));
		self.digits[7] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit7"));
	end;

	self.showFreeSpace = Utils.getNoNil(getUserAttribute(self.id, "showFreeSpace"),false);
	self.maxSpace = 0;
	if self.showFreeSpace then
		self.maxSpace = Utils.getNoNil(getUserAttribute(self.id, "maxSpace"),500000);
		self.digits2 = {};
		self.digits2[1] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit1_2"));
		self.digits2[2] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit2_2"));
		self.digits2[3] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit3_2"));
		self.digits2[4] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit4_2"));
		self.digits2[5] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit5_2"));
		self.digits2[6] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit6_2"));
		self.digits2[7] = Utils.indexToObject(self.id, getUserAttribute(self.id, "digit7_2"));
	end;

	self.firstStart = true;

	g_currentMission:addSiloAmountListener(self, self.fillType);
	self:onSiloAmountChanged(self.fillType, g_currentMission:getSiloAmount(self.fillType));

	self.oldAmount = 0;
	self.isEnabled = true;
	return self;
end;
function DigitalAmountMover:update(dt)
	if self.firstStart then
		self.firstStart = false;
	end;
end;
function DigitalAmountMover:delete()
	g_currentMission:removeSiloAmountListener(self);
end;
function DigitalAmountMover:onSiloAmountChanged(fillType, amount)
	local amount = amount;
	if fillType == Fillable.FILLTYPE_WHEAT_WINDROW then
		amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_BARLEY_WINDROW);
		if Fillable.FILLTYPE_RYE_WINDROW ~= nil then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_RYE_WINDROW);
		end;
		if Fillable.FILLTYPE_DINKEL_WINDROW ~= nil then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_DINKEL_WINDROW);
		end;
		if Fillable.FILLTYPE_OAT_WINDROW ~= nil then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_OAT_WINDROW);
		end;
	elseif fillType == Fillable.FILLTYPE_BARLEY_WINDROW then
		amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_WHEAT_WINDROW);
		if Fillable.FILLTYPE_RYE_WINDROW ~= nil then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_RYE_WINDROW);
		end;
		if Fillable.FILLTYPE_DINKEL_WINDROW ~= nil then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_DINKEL_WINDROW);
		end;
		if Fillable.FILLTYPE_OAT_WINDROW ~= nil then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_OAT_WINDROW);
		end;
	elseif fillType == Fillable.FILLTYPE_DRYGRASS_WINDROW then
		amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_GRASS_WINDROW);
	elseif fillType == Fillable.FILLTYPE_GRASS_WINDROW then
		amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_DRYGRASS_WINDROW);
	else
		if Fillable.FILLTYPE_RYE_WINDROW ~= nil and fillType == Fillable.FILLTYPE_RYE_WINDROW then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_RYE_WINDROW);
			if Fillable.FILLTYPE_DINKEL_WINDROW ~= nil then
				amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_DINKEL_WINDROW);
			end;
			if Fillable.FILLTYPE_OAT_WINDROW ~= nil then
				amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_OAT_WINDROW);
			end;
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_BARLEY_WINDROW);
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_WHEAT_WINDROW);
		end;
		if Fillable.FILLTYPE_DINKEL_WINDROW ~= nil and fillType == Fillable.FILLTYPE_DINKEL_WINDROW then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_DINKEL_WINDROW);
			if Fillable.FILLTYPE_RYE_WINDROW ~= nil then
				amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_RYE_WINDROW);
			end;
			if Fillable.FILLTYPE_OAT_WINDROW ~= nil then
				amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_OAT_WINDROW);
			end;
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_BARLEY_WINDROW);
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_WHEAT_WINDROW);
		end;
		if Fillable.FILLTYPE_OAT_WINDROW ~= nil and fillType == Fillable.FILLTYPE_OAT_WINDROW then
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_OAT_WINDROW);
			if Fillable.FILLTYPE_RYE_WINDROW ~= nil then
				amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_RYE_WINDROW);
			end;
			if Fillable.FILLTYPE_DINKEL_WINDROW ~= nil then
				amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_DINKEL_WINDROW);
			end;
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_BARLEY_WINDROW);
			amount = amount + g_currentMission:getSiloAmount(Fillable.FILLTYPE_WHEAT_WINDROW);
		end;
	end;
	if amount ~= nil then
		self:setDisplay(amount);
	end;
end;

function DigitalAmountMover:setDisplay(amount)
	if self.maxSpace <= 0 then
		self.showFreeSpace = false;
	end;
	local left = self.maxSpace;
	if self.showFreeSpace then
		left = left - amount;
	end;
	if left < 0 then
		left = 0;
	end;
	local amountUnits = string.format("%d", math.floor(amount));
	local digit1 = "0";
	local digit2 = "0";
	local digit3 = "0";
	local digit4 = "0";
	local digit5 = "0";
	local digit6 = "0";
	local digit7 = "0";
	if amount >= 1000000 then
		digit1 = string.sub(amountUnits, 1, 1);
		digit2 = string.sub(amountUnits, 2, 2);
		digit3 = string.sub(amountUnits, 3, 3);
		digit4 = string.sub(amountUnits, 4, 4);
		digit5 = string.sub(amountUnits, 5, 5);
		digit6 = string.sub(amountUnits, 6, 6);
		digit7 = string.sub(amountUnits, 7, 7);
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],true);
		setVisibility(self.digits[5],true);
		setVisibility(self.digits[4],true);
		setVisibility(self.digits[3],true);
		setVisibility(self.digits[2],true);
		setVisibility(self.digits[1],true);
	elseif amount >= 100000 then
		digit2 = string.sub(amountUnits, 1, 1);
		digit3 = string.sub(amountUnits, 2, 2);
		digit4 = string.sub(amountUnits, 3, 3);
		digit5 = string.sub(amountUnits, 4, 4);
		digit6 = string.sub(amountUnits, 5, 5);
		digit7 = string.sub(amountUnits, 6, 6);
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],true);
		setVisibility(self.digits[5],true);
		setVisibility(self.digits[4],true);
		setVisibility(self.digits[3],true);
		setVisibility(self.digits[2],true);
		setVisibility(self.digits[1],false);
	elseif amount >= 10000 then
		digit3 = string.sub(amountUnits, 1, 1);
		digit4 = string.sub(amountUnits, 2, 2);
		digit5 = string.sub(amountUnits, 3, 3);
		digit6 = string.sub(amountUnits, 4, 4);
		digit7 = string.sub(amountUnits, 5, 5);
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],true);
		setVisibility(self.digits[5],true);
		setVisibility(self.digits[4],true);
		setVisibility(self.digits[3],true);
		setVisibility(self.digits[2],false);
		setVisibility(self.digits[1],false);
	elseif amount >= 1000 then
		digit4 = string.sub(amountUnits, 1, 1);
		digit5 = string.sub(amountUnits, 2, 2);
		digit6 = string.sub(amountUnits, 3, 3);
		digit7 = string.sub(amountUnits, 4, 4);
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],true);
		setVisibility(self.digits[5],true);
		setVisibility(self.digits[4],true);
		setVisibility(self.digits[3],false);
		setVisibility(self.digits[2],false);
		setVisibility(self.digits[1],false);
	elseif amount >= 100 then
		digit5 = string.sub(amountUnits, 1, 1);
		digit6 = string.sub(amountUnits, 2, 2);
		digit7 = string.sub(amountUnits, 3, 3);
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],true);
		setVisibility(self.digits[5],true);
		setVisibility(self.digits[4],false);
		setVisibility(self.digits[3],false);
		setVisibility(self.digits[2],false);
		setVisibility(self.digits[1],false);
	elseif amount >= 10 then
		digit6 = string.sub(amountUnits, 1, 1);
		digit7 = string.sub(amountUnits, 2, 2);
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],true);
		setVisibility(self.digits[5],false);
		setVisibility(self.digits[4],false);
		setVisibility(self.digits[3],false);
		setVisibility(self.digits[2],false);
		setVisibility(self.digits[1],false);
	elseif amount >= 0 then
		digit7 = string.sub(amountUnits, 1, 1);
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],false);
		setVisibility(self.digits[5],false);
		setVisibility(self.digits[4],false);
		setVisibility(self.digits[3],false);
		setVisibility(self.digits[2],false);
		setVisibility(self.digits[1],false);
	else
		digit7 = 0;
		setVisibility(self.digits[7],true);
		setVisibility(self.digits[6],false);
		setVisibility(self.digits[5],false);
		setVisibility(self.digits[4],false);
		setVisibility(self.digits[3],false);
		setVisibility(self.digits[2],false);
		setVisibility(self.digits[1],false);
	end;
	setShaderParameter(self.digits[7], "Position", self.digitPosition[digit7], 0, 0, 0, false);
	setShaderParameter(self.digits[6], "Position", self.digitPosition[digit6], 0, 0, 0, false);
	setShaderParameter(self.digits[5], "Position", self.digitPosition[digit5], 0, 0, 0, false);
	setShaderParameter(self.digits[4], "Position", self.digitPosition[digit4], 0, 0, 0, false);
	setShaderParameter(self.digits[3], "Position", self.digitPosition[digit3], 0, 0, 0, false);
	setShaderParameter(self.digits[2], "Position", self.digitPosition[digit2], 0, 0, 0, false);
	setShaderParameter(self.digits[1], "Position", self.digitPosition[digit1], 0, 0, 0, false);

	if self.showFreeSpace then
		local left = left;
		local leftUnits = string.format("%d", math.floor(left));
		local digits21 = "0";
		local digits22 = "0";
		local digits23 = "0";
		local digits24 = "0";
		local digits25 = "0";
		local digits26 = "0";
		local digits27 = "0";
		if left >= 1000000 then
			digits21 = string.sub(leftUnits, 1, 1);
			digits22 = string.sub(leftUnits, 2, 2);
			digits23 = string.sub(leftUnits, 3, 3);
			digits24 = string.sub(leftUnits, 4, 4);
			digits25 = string.sub(leftUnits, 5, 5);
			digits26 = string.sub(leftUnits, 6, 6);
			digits27 = string.sub(leftUnits, 7, 7);
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],true);
			setVisibility(self.digits2[5],true);
			setVisibility(self.digits2[4],true);
			setVisibility(self.digits2[3],true);
			setVisibility(self.digits2[2],true);
			setVisibility(self.digits2[1],true);
		elseif left >= 100000 then
			digits22 = string.sub(leftUnits, 1, 1);
			digits23 = string.sub(leftUnits, 2, 2);
			digits24 = string.sub(leftUnits, 3, 3);
			digits25 = string.sub(leftUnits, 4, 4);
			digits26 = string.sub(leftUnits, 5, 5);
			digits27 = string.sub(leftUnits, 6, 6);
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],true);
			setVisibility(self.digits2[5],true);
			setVisibility(self.digits2[4],true);
			setVisibility(self.digits2[3],true);
			setVisibility(self.digits2[2],true);
			setVisibility(self.digits2[1],false);
		elseif left >= 10000 then
			digits23 = string.sub(leftUnits, 1, 1);
			digits24 = string.sub(leftUnits, 2, 2);
			digits25 = string.sub(leftUnits, 3, 3);
			digits26 = string.sub(leftUnits, 4, 4);
			digits27 = string.sub(leftUnits, 5, 5);
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],true);
			setVisibility(self.digits2[5],true);
			setVisibility(self.digits2[4],true);
			setVisibility(self.digits2[3],true);
			setVisibility(self.digits2[2],false);
			setVisibility(self.digits2[1],false);
		elseif left >= 1000 then
			digits24 = string.sub(leftUnits, 1, 1);
			digits25 = string.sub(leftUnits, 2, 2);
			digits26 = string.sub(leftUnits, 3, 3);
			digits27 = string.sub(leftUnits, 4, 4);
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],true);
			setVisibility(self.digits2[5],true);
			setVisibility(self.digits2[4],true);
			setVisibility(self.digits2[3],false);
			setVisibility(self.digits2[2],false);
			setVisibility(self.digits2[1],false);
		elseif left >= 100 then
			digits25 = string.sub(leftUnits, 1, 1);
			digits26 = string.sub(leftUnits, 2, 2);
			digits27 = string.sub(leftUnits, 3, 3);
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],true);
			setVisibility(self.digits2[5],true);
			setVisibility(self.digits2[4],false);
			setVisibility(self.digits2[3],false);
			setVisibility(self.digits2[2],false);
			setVisibility(self.digits2[1],false);
		elseif left >= 10 then
			digits26 = string.sub(leftUnits, 1, 1);
			digits27 = string.sub(leftUnits, 2, 2);
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],true);
			setVisibility(self.digits2[5],false);
			setVisibility(self.digits2[4],false);
			setVisibility(self.digits2[3],false);
			setVisibility(self.digits2[2],false);
			setVisibility(self.digits2[1],false);
		elseif left >= 0 then
			digits27 = string.sub(leftUnits, 1, 1);
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],false);
			setVisibility(self.digits2[5],false);
			setVisibility(self.digits2[4],false);
			setVisibility(self.digits2[3],false);
			setVisibility(self.digits2[2],false);
			setVisibility(self.digits2[1],false);
		else
			digits27 = 0;
			setVisibility(self.digits2[7],true);
			setVisibility(self.digits2[6],false);
			setVisibility(self.digits2[5],false);
			setVisibility(self.digits2[4],false);
			setVisibility(self.digits2[3],false);
			setVisibility(self.digits2[2],false);
			setVisibility(self.digits2[1],false);
		end;
		setShaderParameter(self.digits2[7], "Position", self.digitPosition[digits27], 0, 0, 0, false);
		setShaderParameter(self.digits2[6], "Position", self.digitPosition[digits26], 0, 0, 0, false);
		setShaderParameter(self.digits2[5], "Position", self.digitPosition[digits25], 0, 0, 0, false);
		setShaderParameter(self.digits2[4], "Position", self.digitPosition[digits24], 0, 0, 0, false);
		setShaderParameter(self.digits2[3], "Position", self.digitPosition[digits23], 0, 0, 0, false);
		setShaderParameter(self.digits2[2], "Position", self.digitPosition[digits22], 0, 0, 0, false);
		setShaderParameter(self.digits2[1], "Position", self.digitPosition[digits21], 0, 0, 0, false);
	else
		if self.digits2 ~= nil then
			setVisibility(self.digits2[7],false);
			setVisibility(self.digits2[6],false);
			setVisibility(self.digits2[5],false);
			setVisibility(self.digits2[4],false);
			setVisibility(self.digits2[3],false);
			setVisibility(self.digits2[2],false);
			setVisibility(self.digits2[1],false);
		end;
	end;
end;
g_onCreateUtil.addOnCreateFunction("DigitalAmountMoverOnCreate", DigitalAmountMover.onCreate);
